<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <!-- Include the CesiumJS JavaScript and CSS files -->
  <script src="https://cesium.com/downloads/cesiumjs/releases/1.115/Build/Cesium/Cesium.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
  <link href="https://cesium.com/downloads/cesiumjs/releases/1.115/Build/Cesium/Widgets/widgets.css" rel="stylesheet">
</head>
<style>
  canvas { display: block; }
  #cesiumContainer {
    width: 100%;
    height: 100vh;
    position: relative; /* 确保父容器是定位元素 */
  }
  #goToLocation {
    position: absolute; /* 绝对定位使其能够悬浮 */
    right: 20px; /* 距离容器右边界20px */
    bottom: 20px; /* 距离容器底部20px */
    z-index: 100; /* 确保按钮在Cesium视图上方 */
    padding: 10px 20px; /* 增加一些内边距使按钮看起来更好 */
    background-color: #007bff; /* 蓝色背景 */
    color: white; /* 文字颜色为白色 */
    border: none; /* 无边框 */
    border-radius: 5px; /* 圆角边框 */
    cursor: pointer; /* 鼠标悬停时显示指针 */
  }
  #goToLocation:hover {
    background-color: #0056b3; /* 鼠标悬停时的背景色 */
  }
</style>

<body>

<div id="cesiumContainer"></div>
<input type="range" id="timeSlider" min="0" max="144" value="72">
<button id="goToLocation">Go to Location</button>
<button id="calculate">calculate</button>
<script type="module">
  // Your access token can be found at: https://ion.cesium.com/tokens.
  // This is the default access token from your ion account
  var longitude = 11.573213852350015; // 例如：北京的经度
  var latitude =  48.13659884837134; // 例如：北京的纬度
  var height = 900.0; // 目标观察高度，单位为米

  // 定义按钮点击事件处理函数
  document.getElementById('goToLocation').addEventListener('click', function() {
    viewer.camera.flyTo({
      destination: Cesium.Cartesian3.fromDegrees(longitude, latitude, height),
      orientation: {
        heading: Cesium.Math.toRadians(0), //
        pitch: Cesium.Math.toRadians(-90), //
        roll: 0.0
      }
    });
  });
  document.getElementById('calculate').addEventListener('click', function() {
    caculate_point_list()
  });
  Cesium.Ion.defaultAccessToken = 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJqdGkiOiI5ZjBmNDMzNC1iYWE1LTQ3MzktYTQ5MC1lZmFjNjk3NTYzN2QiLCJpZCI6MTk0ODIzLCJpYXQiOjE3MDc0NzE0NzJ9.LhKp3KFaLreNR5Ktq9JVUm_JA8a4bhQFe2qCr080Vmk';

  // Initialize the Cesium Viewer in the HTML element with the `cesiumContainer` ID.
  const viewer = new Cesium.Viewer('cesiumContainer', {
    terrain: Cesium.Terrain.fromWorldTerrain(),
    animation:false,//隐藏掉时钟 图中6

    timeline:false,//隐藏时间轴 图中7

    fullscreenButton:false,//隐藏全屏按钮 图中8

    geocoder:false,//隐藏搜索按钮 图中1

    homeButton:false,//隐藏home按钮 图中2

    navigationHelpButton:false,//隐藏帮助按钮 图中5

    sceneModePicker:false,//隐藏切换二三维按钮 图中3

    baseLayerPicker:false,//隐藏切换底图按钮 图中4

    creditContainer:document.createElement("div"),//隐藏logo  图中9

  });
  // 创建一个用于监听屏幕空间事件的处理器
  // viewer.clock.shouldAnimate = false;



  var handler = new Cesium.ScreenSpaceEventHandler(viewer.scene.canvas);
  function calculateDirectionVector(point1, point2) {
    // 计算从点1到点2的向量
    var directionVector = Cesium.Cartesian3.subtract(point2, point1, new Cesium.Cartesian3());

    // 将向量规范化为单位向量
    var unitDirectionVector = Cesium.Cartesian3.normalize(directionVector, new Cesium.Cartesian3());

    return unitDirectionVector;
  }
  function getSunDirection(cartesian) {

    var date = viewer.clock.currentTime

    // 根据经纬度和高度创建点的位置
    var pointPosition = cartesian;

    // 计算太阳位置
// 使用Cesium内置的太阳位置计算功能
    var sunPosition = new Cesium.Cartesian3();
    Cesium.Simon1994PlanetaryPositions.computeSunPositionInEarthInertialFrame(date,sunPosition);
    // var sunPositionCartesian = Cesium.Cartesian3.fromArray(sunPosition);
    var temeToPseudoFixedMatrix = Cesium.Transforms.computeTemeToPseudoFixedMatrix(date);

// 使用转换矩阵将太阳位置从TEME转换到ECEF
    var sunPositionECEF = Cesium.Matrix3.multiplyByVector(temeToPseudoFixedMatrix, sunPosition, new Cesium.Cartesian3());

    // console.log(cartesian,sunPositionECEF,"date")
    // 计算从点位置指向太阳的向量
    var sunDirection= calculateDirectionVector(cartesian,sunPositionECEF)
    //
    // Cesium.Cartesian3.subtract(sunPositionECEF, pointPosition, sunDirection);
    // Cesium.Cartesian3.normalize(sunDirection, sunDirection);
    // var startPoint = Cesium.Cartesian3.fromDegrees(pointPosition);
    // var endPoint = Cesium.Cartesian3.fromDegrees(sunPosition);

// 使用Polyline添加一条线来表示向量
//     add_vector(cartesian,sunDirection,Cesium.Color.WHITE)
//     var vectorLine = viewer.entities.add({
//       polyline: {
//         positions: [pointPosition, sunPositionECEF],
//         width: 2,
//         material: Cesium.Color.WHITE, // 可以根据需要调整线的颜色
//         arcType: Cesium.ArcType.NONE // 确保线段直接连接起点和终点
//       }
//     });

    // viewer.zoomTo(viewer.entities);
    // console.log("Sun Direction at Location:", sunDirection);
    return sunDirection;
  }

  // 监听鼠标左键点击事件
  // handler.setInputAction(function(click) {
  //   var pickedObject = viewer.scene.pick(click.position);
  //   // 确保点击到了对象
  //   if (Cesium.defined(pickedObject)) {
  //     var cartesian = viewer.scene.pickPosition(click.position);
  //     // 确保获取到了有效的坐标
  //     if (Cesium.defined(cartesian)) {
  //       var cartographic = Cesium.Cartographic.fromCartesian(cartesian);
  //       var longitude = Cesium.Math.toDegrees(cartographic.longitude);
  //       var latitude = Cesium.Math.toDegrees(cartographic.latitude);
  //       var height = cartographic.height;
  //       console.log('Longitude: ' + longitude + ', Latitude: ' + latitude + ', Height: ' + height);
  //     }
  //
  //   }
  // }, Cesium.ScreenSpaceEventType.LEFT_CLICK);
  function isSunBlockedByModel(viewer, pointPosition,direction) {
    // 确保点位置和太阳位置是Cesium.Cartesian3实例


    // 根据经纬度和高度创建点的位置
    // 计算太阳位置


    // 规范化方向向量
    Cesium.Cartesian3.normalize(direction, direction);

    // 创建射线
    var ray = new Cesium.Ray(pointPosition, direction);
    var startPoint = pointPosition;

// 定义方向向量（在这个例子中，我们假设这个向量已经是规范化的）
// 注意：这里的方向向量是一个笛卡尔坐标系中的向量，不是经纬度
// 根据需要缩放方向向量（例如，将其长度扩大10000米）
// add_vector(startPoint,direction,"RED")
    // 使用射线检测是否与场景中的3D模型相交
    var result = viewer.scene.pickFromRay(ray);

    // 如果result不是undefined，说明射线与某个模型相交，即视线被遮挡
    return result !== undefined;
  }
  let globalPageX = 0;
  let globalPageY = 0;

  // 全局监听鼠标移动事件来更新pageX和pageY
  document.addEventListener('click', function(event) {
    globalPageX = event.pageX;
    globalPageY = event.pageY;
    const oldContainer = document.getElementById('canvasContainer');
    if (oldContainer) {
      document.body.removeChild(oldContainer);
    }
  });
  function add_vector(startPoint,direction,color_str){
    var scaledDirectionVector = Cesium.Cartesian3.multiplyByScalar(direction, 20, new Cesium.Cartesian3());

// 计算终点坐标
    var endPoint = Cesium.Cartesian3.add(startPoint, scaledDirectionVector, new Cesium.Cartesian3());

// 使用Polyline添加一条线来表示向量
    viewer.entities.add({
      polyline: {
        positions: [startPoint, endPoint],
        width: 2,
        material: color_str, // 可以根据需要调整线的颜色
        // material: Cesium.Color.color_str, // 可以根据需要调整线的颜色
        arcType: Cesium.ArcType.NONE // 确保线段直接连接起点和终点
      }
    });
    // 使用射线检测是否与场景中的3D模型相交

  }
  function caculate_point_list(){
    const point_list=[[11.572176066553844, 48.13941501948902], [11.572265607714547, 48.139405943116394], [11.572355148875248, 48.13939686674376], [11.572444690035951, 48.13938779037113], [11.572534231196652, 48.139378713998504], [11.572623772357355, 48.13936963762587], [11.572713313518056, 48.13936056125324], [11.572801731530616, 48.139351598728936], [11.572891272691319, 48.13934252235631], [11.57298081385202, 48.13933344598368], [11.573070355012723, 48.139324369611046], [11.573159896173424, 48.13931529323842], [11.573249437334127, 48.13930621686579], [11.57333897849483, 48.13929714049316], [11.57342851965553, 48.13928806412053], [11.573518060816234, 48.1392789877479], [11.573607601976935, 48.13926991137527], [11.573697143137638, 48.139260835002645], [11.573786684298339, 48.13925175863002], [11.573876225459042, 48.13924268225738], [11.573965766619745, 48.139233605884755], [11.574055307780446, 48.13922452951213], [11.574144848941149, 48.1392154531395], [11.57423439010185, 48.13920637676687], [11.577934261552436, 48.1390110403947], [11.578023963294232, 48.13900371936207], [11.578113665036028, 48.13899639832945], [11.578203366777824, 48.13898907729683], [11.57829306851962, 48.1389817562642], [11.574280945282831, 48.139201657683856], [11.574282007136816, 48.13911166394815], [11.5742830689908, 48.13902167021244], [11.574284130844784, 48.138931676476744], [11.574285192698769, 48.13884168274104], [11.574286254552753, 48.13875168900533], [11.574287316406737, 48.138661695269626], [11.574288378260722, 48.13857170153392], [11.574289440114706, 48.13848170779821], [11.57429050196869, 48.138391714062514], [11.574291331638, 48.138321398330106], [11.574292393491984, 48.1382314045944], [11.574293455345968, 48.138141410858694], [11.572965927619393, 48.1374030705887], [11.572973484840817, 48.1373133884366], [11.57298104206224, 48.13722370628451], [11.572988599283665, 48.137134024132415], [11.57299615650509, 48.13704434198032], [11.573003713726512, 48.13695465982822], [11.573011270947937, 48.136864977676126], [11.573018828169362, 48.13677529552403], [11.573026385390785, 48.13668561337194], [11.573033863180207, 48.13659687384578], [11.573041420401632, 48.13650719169369], [11.573048977623055, 48.136417509541594], [11.57305653484448, 48.1363278273895], [11.573064092065904, 48.13623814523741], [11.573071649287327, 48.136148463085306], [11.573079206508751, 48.13605878093321], [11.573086763730176, 48.13596909878112], [11.573094320951599, 48.135879416629024], [11.573101878173023, 48.13578973447693], [11.573109435394446, 48.135700052324836], [11.572915116775691, 48.13800604694167], [11.572922673997116, 48.137916364789575], [11.572930231218539, 48.13782668263748], [11.572937788439964, 48.13773700048539], [11.572945345661388, 48.13764731833329], [11.572952902882811, 48.13755763618119], [11.572960460104236, 48.1374679540291], [11.57275585384838, 48.13989603285958], [11.572763411069804, 48.13980635070749], [11.572770968291227, 48.139716668555394], [11.572778525512652, 48.1396269864033], [11.572786082734076, 48.139537304251206], [11.5727936399555, 48.139447622099105], [11.572801197176924, 48.13935793994701], [11.572801731530616, 48.13935159872894], [11.57280928875204, 48.13926191657685], [11.572816845973465, 48.139172234424755], [11.572824403194888, 48.13908255227266], [11.572831960416313, 48.13899287012057], [11.572839517637737, 48.13890318796847], [11.572847074859162, 48.13881350581637], [11.572854632080585, 48.13872382366428], [11.572854980691053, 48.13871968667593], [11.572862537912478, 48.13863000452383], [11.5728700951339, 48.13854032237174], [11.572877652355325, 48.138450640219645], [11.572882360277637, 48.13839477092839], [11.572889917499062, 48.1383050887763], [11.572897474720486, 48.138215406624205], [11.57290503194191, 48.13812572447211], [11.572912589163334, 48.13803604232002], [11.574295905892248, 48.137933723344645], [11.574385782688095, 48.13792901573717], [11.574475659483943, 48.1379243081297], [11.574565536279792, 48.137919600522224], [11.57465541307564, 48.13791489291475], [11.574745289871487, 48.13791018530728], [11.57256781472583, 48.138024238085556], [11.572657691521677, 48.13801953047808], [11.572747568317524, 48.13801482287061], [11.572837445113374, 48.138010115263135], [11.57291511677569, 48.13800604694167], [11.573004993571537, 48.138001339334195], [11.573094870367385, 48.13799663172672], [11.573184747163234, 48.13799192411925], [11.573274623959081, 48.137987216511775], [11.573364500754929, 48.1379825089043], [11.573454377550776, 48.13797780129683], [11.573544254346624, 48.137973093689354], [11.573634131142473, 48.13796838608188], [11.57372400793832, 48.13796367847441], [11.573813884734168, 48.13795897086693], [11.573903761530016, 48.13795426325946], [11.573993638325863, 48.137949555651986], [11.574083515121712, 48.13794484804451], [11.57417339191756, 48.13794014043704], [11.574263268713407, 48.137935432829565], [11.577793995635139, 48.13775049881754], [11.577883872430986, 48.137745791210065], [11.577973468834758, 48.1377388514566], [11.578061717639402, 48.13772118373238], [11.578149966444045, 48.137703516008166], [11.578238215248689, 48.13768584828395], [11.578326464053333, 48.137668180559736], [11.578414712857978, 48.13765051283552], [11.57850296166262, 48.137632845111305], [11.578591210467264, 48.13761517738709], [11.578679459271909, 48.137597509662875], [11.578767708076553, 48.13757984193866], [11.578855956881196, 48.137562174214445], [11.57894420568584, 48.13754450649023], [11.579032454490484, 48.137526838766014], [11.579120703295127, 48.1375091710418], [11.579208952099771, 48.137491503317584], [11.579297200904415, 48.13747383559337], [11.57938544970906, 48.13745616786915], [11.579473698513702, 48.13743850014494], [11.579561947318346, 48.13742083242072], [11.57965019612299, 48.13740316469651], [11.579738444927635, 48.13738549697229], [11.579826693732278, 48.13736782924808], [11.579914942536922, 48.13735016152386], [11.580003191341566, 48.137332493799654], [11.580091440146209, 48.13731482607544], [11.580179688950853, 48.137297158351224], [11.580267937755497, 48.13727949062701], [11.580336461431179, 48.137310968167796], [11.580388007851784, 48.13738474463099], [11.580439554272392, 48.137458521094196], [11.580491100693, 48.1375322975574], [11.580542647113607, 48.1376060740206], [11.580594193534214, 48.137679850483806], [11.58064573995482, 48.137753626947], [11.580697286375427, 48.137827403410206], [11.580748832796035, 48.13790117987341], [11.580800379216642, 48.13797495633661], [11.58085192563725, 48.13804873279982], [11.580903472057855, 48.13812250926301], [11.580955018478463, 48.13819628572622], [11.58100656489907, 48.13827006218942], [11.581058111319678, 48.138343838652624], [11.581109657740285, 48.13841761511582], [11.58116120416089, 48.138491391579024], [11.581212750581498, 48.13856516804223], [11.581264297002106, 48.13863894450543], [11.581315843422713, 48.138712720968634], [11.58136738984332, 48.13878649743183], [11.581418936263926, 48.138860273895034], [11.581470482684534, 48.13893405035824], [11.577347142424022, 48.13777390429719], [11.57743701921987, 48.13776919668972], [11.577526896015717, 48.137764489082244], [11.577616772811567, 48.13775978147477], [11.577706649607414, 48.1377550738673], [11.574816009645362, 48.13790648111497], [11.57490588644121, 48.137901773507494], [11.574995763237057, 48.13789706590002], [11.575085640032906, 48.13789235829255], [11.575175516828754, 48.13788765068507], [11.575265393624601, 48.1378829430776], [11.575355270420449, 48.137878235470126], [11.575445147216296, 48.13787352786265], [11.575535024012146, 48.13786882025518], [11.575624900807993, 48.137864112647705], [11.57571477760384, 48.13785940504023], [11.575804654399688, 48.13785469743276], [11.575894531195535, 48.137849989825284], [11.575984407991385, 48.13784528221781], [11.57603086856616, 48.137842848684805], [11.576120745362008, 48.13783814107733], [11.576210622157856, 48.13783343346986], [11.576300498953705, 48.137828725862384], [11.576390375749552, 48.13782401825491], [11.5764802525454, 48.13781931064744], [11.576570129341247, 48.13781460303996], [11.576660006137095, 48.13780989543249], [11.576749882932944, 48.137805187825016], [11.576839759728792, 48.13780048021754], [11.576929636524639, 48.13779577261007], [11.577019513320487, 48.137791065002595], [11.577109390116334, 48.13778635739512], [11.577199266912183, 48.13778164978765], [11.57728914370803, 48.137776942180174], [11.577728300716931, 48.137160111805464], [11.577793995635139, 48.13775049881754], [11.577784042376523, 48.13766105088496], [11.577774089117906, 48.13757160295238], [11.57776413585929, 48.137482155019796], [11.577754182600675, 48.137392707087216], [11.57774422934206, 48.137303259154635], [11.577734276083442, 48.137213811222054], [11.577958269572314, 48.13922679563891], [11.577948316313698, 48.13913734770633], [11.57793836305508, 48.13904789977375], [11.577934261552436, 48.1390110403947], [11.57792430829382, 48.13892159246212], [11.577914355035203, 48.13883214452954], [11.577904401776587, 48.13874269659696], [11.577894448517972, 48.138653248664376], [11.577884495259356, 48.138563800731795], [11.577874542000739, 48.138474352799214], [11.577864588742123, 48.13838490486663], [11.577854635483508, 48.13829545693405], [11.57784468222489, 48.13820600900147], [11.57783697634822, 48.138136757838254], [11.577827023089604, 48.13804730990567], [11.577817069830987, 48.13795786197309], [11.577807116572371, 48.13786841404051], [11.577797163313756, 48.13777896610793], [11.572489465091435, 48.138871259816945], [11.572572600441742, 48.13883678499237], [11.572655735792049, 48.1388023101678], [11.572738871142356, 48.138767835343224], [11.572822006492663, 48.13873336051865], [11.574293671565945, 48.138123085887656], [11.574376806916252, 48.13808861106308], [11.574459942266559, 48.13805413623851], [11.574543077616866, 48.138019661413935], [11.574626212967173, 48.13798518658937], [11.57470934831748, 48.137950711764795], [11.574792483667787, 48.13791623694022], [11.574816009645366, 48.13790648111497], [11.574816009645373, 48.13790648111497], [11.57481600964538, 48.13790648111497], [11.574816009645389, 48.13790648111496], [11.574899144995696, 48.13787200629039], [11.574982280346003, 48.13783753146581], [11.57506541569631, 48.13780305664124], [11.575148551046617, 48.137768581816665], [11.575231686396924, 48.13773410699209], [11.57531482174723, 48.13769963216752], [11.575397957097536, 48.13766515734295], [11.575481092447843, 48.13763068251838], [11.57556422779815, 48.137596207693804], [11.575647363148457, 48.13756173286923], [11.575730498498764, 48.137527258044656], [11.575813633849071, 48.13749278322008], [11.575896769199378, 48.13745830839551], [11.575979904549685, 48.137423833570935], [11.575991269073917, 48.137419120894826], [11.576074404424224, 48.13738464607025], [11.576157539774531, 48.13735017124568], [11.576240675124838, 48.137315696421105], [11.572854980691053, 48.13871968667593], [11.57293811604136, 48.13868521185135], [11.573021251391667, 48.13865073702678], [11.573104386741974, 48.138616262202206], [11.573187522092281, 48.13858178737764], [11.573270657442588, 48.138547312553065], [11.573353792792895, 48.13851283772849], [11.573436928143202, 48.13847836290392], [11.57352006349351, 48.138443888079344], [11.573603198843816, 48.13840941325477], [11.573686334194123, 48.138374938430196], [11.573747101447193, 48.13834973927747], [11.5738302367975, 48.1383152644529], [11.573913372147807, 48.138280789628325], [11.573996507498114, 48.13824631480375], [11.574079642848421, 48.138211839979185], [11.574162778198728, 48.13817736515461], [11.574245913549035, 48.13814289033004], [11.577302330845678, 48.136872018197], [11.577392274010245, 48.136868820205855], [11.577482217174815, 48.13686562221471], [11.577572160339383, 48.136862424223565], [11.577662103503952, 48.13685922623242], [11.57775204666852, 48.13685602824127], [11.57784198983309, 48.13685283025012], [11.577931932997657, 48.13684963225898], [11.578021876162227, 48.13684643426783], [11.578111819326795, 48.13684323627668], [11.574307176609436, 48.13697851296819], [11.574397119774003, 48.13697531497704], [11.574487062938573, 48.136972116985895], [11.57457700610314, 48.136968918994754], [11.57466694926771, 48.136965721003605], [11.574756892432278, 48.13696252301246], [11.574846835596848, 48.13695932502131], [11.574936778761415, 48.13695612703017], [11.575026721925985, 48.13695292903902], [11.575116665090553, 48.13694973104787], [11.575206608255122, 48.13694653305672], [11.57529655141969, 48.136943335065574], [11.57538649458426, 48.13694013707443], [11.575476437748828, 48.136936939083284], [11.575566380913397, 48.136933741092136], [11.575656324077965, 48.13693054310099], [11.575746267242534, 48.13692734510985], [11.575836210407102, 48.1369241471187], [11.575926153571672, 48.13692094912755], [11.575928095671891, 48.13692088007484], [11.576018038836459, 48.13691768208369], [11.576107982001028, 48.13691448409254], [11.576197925165596, 48.1369112861014], [11.576287868330166, 48.13690808811025], [11.576377811494734, 48.136904890119105], [11.576467754659303, 48.13690169212796], [11.576557697823871, 48.136898494136815], [11.57664764098844, 48.13689529614567], [11.576737584153008, 48.13689209815452], [11.576827527317578, 48.13688890016337], [11.576917470482146, 48.13688570217222], [11.577007413646715, 48.13688250418108], [11.577097356811283, 48.13687930618993], [11.577187299975852, 48.136876108198784], [11.57727724314042, 48.136872910207636], [11.572473795164555, 48.137428177378936], [11.572563678272726, 48.137423591872896], [11.572653561380896, 48.13741900636686], [11.572743444489067, 48.13741442086082], [11.572833327597237, 48.13740983535479], [11.572923210705408, 48.13740524984875], [11.572965927619391, 48.1374030705887], [11.573055810727562, 48.137398485082656], [11.573145693835732, 48.13739389957662], [11.573235576943903, 48.13738931407058], [11.573325460052073, 48.13738472856454], [11.573415343160242, 48.13738014305851], [11.573505226268413, 48.13737555755247], [11.573595109376583, 48.13737097204643], [11.573684992484754, 48.13736638654039], [11.573774875592925, 48.13736180103435], [11.573864758701095, 48.13735721552832], [11.573954641809266, 48.13735263002228], [11.574044524917436, 48.13734804451624], [11.574134408025607, 48.137343459010204], [11.574224291133778, 48.13733887350416], [11.577728300716931, 48.137160111805464], [11.577818183825102, 48.13715552629942], [11.577908066933272, 48.13715094079339], [11.577997950041443, 48.13714635528735], [11.578087833149613, 48.13714176978131], [11.578177716257782, 48.137137184275275], [11.578267599365953, 48.137132598769234], [11.578357482474123, 48.1371280132632], [11.578447365582294, 48.13712342775716], [11.578537248690465, 48.13711884225112], [11.578627131798635, 48.137114256745086], [11.578717014906806, 48.137109671239045], [11.578806898014976, 48.137105085733005], [11.578896781123147, 48.13710050022697], [11.578986664231318, 48.13709591472093], [11.579076547339486, 48.13709132921489], [11.579166430447657, 48.137086743708856], [11.579256313555828, 48.137082158202816], [11.579346196663998, 48.13707757269678], [11.579436079772169, 48.13707298719074], [11.57952596288034, 48.1370684016847], [11.57961584598851, 48.13706381617867], [11.57970572909668, 48.13705923067263], [11.579795612204851, 48.137054645166586], [11.579885495313022, 48.13705005966055], [11.57997537842119, 48.13704547415451], [11.577331572895947, 48.13718035140171], [11.577331572895948, 48.13718035140171], [11.577421456004119, 48.13717576589567], [11.57751133911229, 48.137171180389636], [11.57760122222046, 48.137166594883595], [11.57769110532863, 48.137162009377555], [11.574302972005901, 48.13733485949506], [11.574392855114072, 48.13733027398902], [11.574482738222242, 48.13732568848299], [11.574572621330413, 48.13732110297695], [11.574662504438583, 48.137316517470914], [11.574752387546754, 48.137311931964874], [11.574842270654923, 48.13730734645883], [11.574932153763093, 48.1373027609528], [11.575022036871264, 48.13729817544676], [11.575111919979435, 48.137293589940725], [11.575201803087605, 48.137289004434685], [11.575291686195776, 48.137284418928644], [11.575381569303946, 48.13727983342261], [11.575471452412117, 48.13727524791657], [11.575561335520288, 48.137270662410536], [11.575651218628458, 48.137266076904496], [11.575741101736627, 48.137261491398455], [11.575830984844798, 48.13725690589242], [11.575920867952968, 48.13725232038638], [11.575969803413102, 48.137249823878946], [11.576059686521273, 48.137245238372905], [11.576149569629443, 48.13724065286687], [11.576239452737614, 48.13723606736083], [11.576329335845784, 48.13723148185479], [11.576419218953953, 48.13722689634876], [11.576509102062124, 48.137222310842716], [11.576598985170294, 48.137217725336676], [11.576688868278465, 48.13721313983064], [11.576778751386636, 48.1372085543246], [11.576868634494806, 48.13720396881856], [11.576958517602977, 48.13719938331253], [11.577048400711147, 48.13719479780649], [11.577138283819318, 48.137190212300446], [11.577228166927489, 48.13718562679441], [11.577318050035657, 48.13718104128837], [11.572552144798953, 48.1365915892764], [11.572642139383857, 48.13659257653918], [11.572732133968763, 48.13659356380196], [11.572822128553668, 48.13659455106474], [11.572912123138574, 48.13659553832752], [11.573002117723478, 48.1365965255903], [11.577280654795382, 48.13664346219661], [11.577370649380287, 48.13664444945939], [11.577460643965193, 48.13664543672217], [11.577550638550097, 48.13664642398495], [11.577640633135003, 48.13664741124773], [11.577730627719907, 48.13664839851051], [11.577820622304811, 48.13664938577328], [11.577910616889717, 48.13665037303606], [11.578000611474621, 48.13665136029884], [11.578090606059526, 48.13665234756162], [11.578180600644432, 48.1366533348244], [11.578270595229336, 48.13665432208718], [11.573033863180205, 48.13659687384578], [11.57312385776511, 48.13659786110856], [11.573213852350015, 48.13659884837134], [11.57330384693492, 48.13659983563412], [11.573393841519826, 48.1366008228969], [11.57348383610473, 48.13660181015968], [11.573573830689634, 48.13660279742246], [11.57366382527454, 48.13660378468524], [11.573753819859444, 48.13660477194802], [11.573843814444349, 48.136605759210795], [11.573933809029255, 48.136606746473575], [11.574023803614159, 48.136607733736355], [11.574113798199065, 48.136608720999135], [11.574203792783969, 48.136609708261915], [11.574293787368873, 48.136610695524695], [11.57438378195378, 48.136611682787475], [11.574473776538683, 48.136612670050255], [11.574563771123588, 48.136613657313035], [11.574653765708494, 48.136614644575815], [11.574743760293398, 48.136615631838595], [11.574833754878304, 48.136616619101375], [11.574923749463208, 48.136617606364155], [11.575013744048112, 48.136618593626935], [11.575103738633018, 48.136619580889715], [11.575193733217922, 48.136620568152495], [11.575283727802828, 48.136621555415275], [11.575373722387733, 48.136622542678055], [11.575463716972637, 48.13662352994083], [11.575553711557543, 48.13662451720361], [11.575643706142447, 48.13662550446639], [11.575733700727351, 48.13662649172917], [11.575823695312257, 48.13662747899195], [11.575890988096493, 48.13662821721038], [11.575980982681397, 48.13662920447316], [11.576070977266303, 48.13663019173594], [11.576160971851207, 48.13663117899872], [11.576250966436113, 48.1366321662615], [11.576340961021018, 48.13663315352428], [11.576430955605922, 48.13663414078706], [11.576520950190828, 48.13663512804983], [11.576610944775732, 48.13663611531261], [11.576700939360636, 48.13663710257539], [11.576790933945542, 48.13663808983817], [11.576880928530446, 48.13663907710095], [11.576970923115352, 48.13664006436373], [11.577060917700257, 48.13664105162651], [11.57715091228516, 48.13664203888929], [11.577240906870067, 48.13664302615207], [11.57603086856616, 48.137842848684805], [11.57603086856616, 48.137752848684805], [11.576022241101917, 48.13766339345468], [11.576010920375944, 48.137574108287026], [11.575999599649974, 48.137484823119365], [11.57603086856616, 48.13944639006362], [11.57603086856616, 48.13935639006362], [11.57603086856616, 48.13926639006362], [11.57603086856616, 48.13917639006362], [11.57603086856616, 48.139154664320614], [11.57603086856616, 48.139064664320614], [11.57603086856616, 48.138974664320614], [11.57603086856616, 48.138884664320614], [11.57603086856616, 48.13879466432061], [11.57603086856616, 48.13870466432061], [11.57603086856616, 48.13861466432061], [11.57603086856616, 48.13852466432061], [11.57603086856616, 48.13843466432061], [11.57603086856616, 48.13834466432061], [11.57603086856616, 48.13825466432061], [11.57603086856616, 48.138230811432585], [11.57603086856616, 48.138140811432585], [11.57603086856616, 48.138050811432585], [11.57603086856616, 48.137960811432585], [11.57603086856616, 48.137870811432585], [11.573747101447191, 48.13834973927747], [11.573836979662198, 48.13834505884297], [11.573926857877206, 48.13834037840847], [11.574016736092213, 48.13833569797397], [11.57410661430722, 48.13833101753947], [11.574196492522228, 48.13832633710497], [11.574286370737235, 48.13832165667047], [11.57256781472583, 48.13841115098058], [11.572657692940837, 48.13840647054608], [11.572747571155844, 48.13840179011158], [11.572837449370851, 48.13839710967708], [11.572882360277637, 48.13839477092839], [11.572972238492644, 48.13839009049389], [11.573062116707652, 48.13838541005939], [11.57315199492266, 48.13838072962489], [11.573241873137667, 48.13837604919039], [11.573331751352674, 48.13837136875589], [11.573421629567681, 48.13836668832139], [11.573511507782687, 48.13836200788689], [11.573601385997694, 48.13835732745239], [11.573691264212702, 48.138352647017896], [11.57783697634822, 48.138136757838254], [11.577926854563227, 48.13813207740375], [11.577368935306303, 48.138161131213266], [11.57745881352131, 48.138156450778766], [11.577548691736318, 48.138151770344265], [11.577638569951326, 48.138147089909765], [11.577728448166333, 48.138142409475265], [11.57781832638134, 48.13813772904077], [11.574291331638, 48.138321398330106], [11.574381209853007, 48.138316717895606], [11.574471088068014, 48.138312037461105], [11.574560966283022, 48.138307357026605], [11.574650844498029, 48.138302676592104], [11.574740722713036, 48.138297996157604], [11.574830600928044, 48.13829331572311], [11.574920479143051, 48.13828863528861], [11.575010357358057, 48.13828395485411], [11.575100235573064, 48.13827927441961], [11.575190113788071, 48.13827459398511], [11.575279992003079, 48.13826991355061], [11.575369870218086, 48.13826523311611], [11.575459748433094, 48.13826055268161], [11.575549626648101, 48.13825587224711], [11.575639504863108, 48.13825119181261], [11.575729383078116, 48.13824651137811], [11.575819261293123, 48.138241830943606], [11.57590913950813, 48.13823715050911], [11.575999017723138, 48.13823247007461], [11.57603086856616, 48.138230811432585], [11.576120746781168, 48.138226130998085], [11.576210624996175, 48.138221450563584], [11.576300503211183, 48.138216770129084], [11.57639038142619, 48.13821208969458], [11.576480259641198, 48.13820740926008], [11.576570137856205, 48.13820272882558], [11.576660016071212, 48.13819804839109], [11.576749894286218, 48.13819336795659], [11.576839772501225, 48.13818868752209], [11.576929650716233, 48.13818400708759], [11.57701952893124, 48.13817932665309], [11.577109407146247, 48.13817464621859], [11.577199285361255, 48.13816996578409], [11.577289163576262, 48.13816528534959], [11.574302972005901, 48.13733485949506], [11.574304033859885, 48.13724486575936], [11.57430509571387, 48.13715487202365], [11.574306157567854, 48.13706487828795], [11.574293671565945, 48.138123085887656], [11.57429473341993, 48.13803309215195], [11.574295795273914, 48.137943098416244], [11.574295905892248, 48.137933723344645], [11.574296967746232, 48.13784372960894], [11.574298029600216, 48.13775373587323], [11.5742990914542, 48.13766374213753], [11.574300153308183, 48.13757374840183], [11.574301215162167, 48.13748375466612], [11.574302277016152, 48.137393760930415], [11.574275836755676, 48.139634613108605], [11.57427689860966, 48.1395446193729], [11.574277960463645, 48.13945462563719], [11.574279022317628, 48.13936463190149], [11.574280084171612, 48.13927463816579], [11.577465886926266, 48.13904926692018], [11.577555588668062, 48.139041945887556], [11.577645290409858, 48.139034624854936], [11.577734992151655, 48.13902730382231], [11.57782469389345, 48.139019982789684], [11.577914395635249, 48.13901266175706], [11.574280945282831, 48.139201657683856], [11.574370486443534, 48.13919258131123], [11.574460027604236, 48.1391835049386], [11.574549568764938, 48.13917442856597], [11.57463910992564, 48.13916535219334], [11.574729042519975, 48.1391635290081], [11.574819040433475, 48.139162916174016], [11.574909038346975, 48.13916230333992], [11.574999036260476, 48.13916169050584], [11.575089034173976, 48.13916107767175], [11.575179032087476, 48.13916046483766], [11.575269030000976, 48.13915985200357], [11.575359027914477, 48.13915923916949], [11.575449025827977, 48.139158626335394], [11.575539023741475, 48.13915801350131], [11.575629021654976, 48.13915740066722], [11.575719019568476, 48.13915678783314], [11.575809017481976, 48.139156174999044], [11.575899015395477, 48.13915556216496], [11.575989013308977, 48.13915494933087], [11.57603086856616, 48.139154664320614], [11.57612086647966, 48.13915405148653], [11.576210787727147, 48.13915170219065], [11.576300489468943, 48.13914438115803], [11.57639019121074, 48.13913706012541], [11.576479892952536, 48.13912973909278], [11.576569594694332, 48.13912241806016], [11.576659296436128, 48.139115097027535], [11.576748998177925, 48.139107775994916], [11.576838699919723, 48.13910045496229], [11.576928401661519, 48.13909313392966], [11.577018103403315, 48.139085812897044], [11.577107805145111, 48.13907849186442], [11.577197506886908, 48.13907117083179], [11.577287208628704, 48.13906384979917], [11.5773769103705, 48.139056528766545], [11.577331572895947, 48.13718035140171], [11.577323075504186, 48.13709075344229], [11.577314578112423, 48.13700115548286], [11.577306080720662, 48.13691155752343], [11.577302330845678, 48.136872018197], [11.577293833453917, 48.13678242023758], [11.577285336062154, 48.13669282227815], [11.577280654795382, 48.13664346219661], [11.57727215740362, 48.136553864237186], [11.577347142424022, 48.137773904297184], [11.577347142424022, 48.137683904297184], [11.577347142424022, 48.137593904297184], [11.577347142424022, 48.13750390429718], [11.577347142424022, 48.13741390429718], [11.577345196060097, 48.1373239963863], [11.577336698668335, 48.13723439842687], [11.577519511619695, 48.139540501672364], [11.577509744963644, 48.13945103317271], [11.577499978307591, 48.13936156467307], [11.57749021165154, 48.139272096173414], [11.577480444995487, 48.13918262767377], [11.577470678339436, 48.13909315917412], [11.577465886926266, 48.13904926692018], [11.577456120270215, 48.13895979842053], [11.577446353614162, 48.138870329920884], [11.577436586958111, 48.13878086142123], [11.57742682030206, 48.13869139292159], [11.577417053646007, 48.138601924421934], [11.577407286989956, 48.13851245592228], [11.577397520333903, 48.138422987422636], [11.577387753677852, 48.138333518922984], [11.577377987021801, 48.13824405042333], [11.577368935306303, 48.138161131213266], [11.577359168650252, 48.138071662713614], [11.5773494019942, 48.13798219421397], [11.577347142424022, 48.13789231717953], [11.577347142424022, 48.13780231717953], [11.575991269073917, 48.137419120894826], [11.575979948347944, 48.13732983572717], [11.575969803413102, 48.13724982387894], [11.57595848268713, 48.137160538711285], [11.575947161961157, 48.137071253543624], [11.575935841235184, 48.13698196837597], [11.575928095671891, 48.13692088007484], [11.575916774945918, 48.136831594907186], [11.575905454219948, 48.136742309739525], [11.575894133493975, 48.13665302457187], [11.575890988096493, 48.13662821721038], [11.57587966737052, 48.136538932042725], [11.575868346644548, 48.136449646875064]]
    var reflect_list=[]
    var reflect
    var promises = []; // 用于存储所有的promise

    var ellipsoid = viewer.scene.globe.ellipsoid;
    var positions = point_list.map(each_point_ori =>
            Cesium.Cartographic.fromDegrees(each_point_ori[0], each_point_ori[1])
    );

    Cesium.sampleTerrain(viewer.terrainProvider, 11, positions).then(function(updatedPositions) {
      updatedPositions.forEach((updatedPos, index) => {
        var cartesian3 = ellipsoid.cartographicToCartesian(updatedPos);
        var each_point = {'position': viewer.scene.cartesianToCanvasCoordinates(cartesian3)};
        var reflect = draw_diagram(each_point, cartesian3);
        reflect_list.push(reflect);
      });

      console.log(reflect_list.length);
      console.log(reflect_list);
    });
  }

  function calculate_normal(movement,cartesian_3){
    if (cartesian_3===''){
      var cartesian = viewer.scene.pickPosition(movement.position);
    }else {
      var cartesian = cartesian_3

    }

    //
    // console.log(cartesian,'cartesian')
    if (Cesium.defined(cartesian)) {
      // 计算法向量，即位置向量的标准化
      var screenP0 = movement.position;
      var screenP1 = new Cesium.Cartesian2(movement.position.x, movement.position.y - 5);
      var screenP2 = new Cesium.Cartesian2(movement.position.x - 5, movement.position.y);

// get the cartesian coordinates for each of them
      var P0 = viewer.scene.pickPosition(screenP0);
      var P1 = viewer.scene.pickPosition(screenP1);
      var P2 = viewer.scene.pickPosition(screenP2);
      if (typeof P0 === 'undefined') {
        console.log('not in view');
        console.log(movement,'move')
        console.log(cartesian,'cartesian')
      }
// calculate the Normal Vector by Cesium.Cartesian3.cross()
      var vec1 = Cesium.Cartesian3.subtract(P1, P0, new Cesium.Cartesian3());
      var vec2 = Cesium.Cartesian3.subtract(P2, P0, new Cesium.Cartesian3());
      var surfaceNormal = Cesium.Cartesian3.cross(vec1, vec2, new Cesium.Cartesian3());
      // console.log("Surface Normal: ", surfaceNormal);
      // add_vector(cartesian,surfaceNormal,Cesium.Color.BLUE)
      // 如果需要，转换法向量为经纬度表示
      // var normalCartographic = ellipsoid.cartesianToCartographic(surfaceNormal);
      // console.log("Normal in Lat/Lon: ", Cesium.Math.toDegrees(normalCartographic.latitude), Cesium.Math.toDegrees(normalCartographic.longitude));
      var sunDirection = getSunDirection(cartesian); // 使用上面提供的函数获取太阳方向
      // var surfaceNormal = new Cesium.Cartesian3(0, 0, 1); // 假设平面法线朝上
      add_vector(cartesian,sunDirection,Cesium.Color.RED)
// 计算光照强度
      var isblock=isSunBlockedByModel(viewer,cartesian,sunDirection)
      // console.log(isblock)
      if (!isblock){
        var lightIntensity = Math.max(Cesium.Cartesian3.dot(surfaceNormal, sunDirection), 0);

      }else {
        // console.log("block")
        lightIntensity=0
      }
      // console.log("Light Intensity:", lightIntensity);
      return lightIntensity



    }
  }

  handler.setInputAction(function(movement) {
    draw_diagram(movement,'')


  }, Cesium.ScreenSpaceEventType.LEFT_CLICK);

  viewer.scene.globe.enableLighting = true
  viewer.shadows = true
  viewer.terrainShadows = Cesium.ShadowMode.RECEIVE_ONLY
  //viewer.shadowMap.softShadows  = true
  viewer.shadowMap.darkness = 0.2 //阴影透明度--越大越透明
  let time = 0
  // const buildingTileset = await Cesium.createOsmBuildingsAsync();
  const tileset = viewer.scene.primitives.add(
          await Cesium.Cesium3DTileset.fromIonAssetId(96188),
  );
  viewer.scene.primitives.add(tileset);
  let baseTime = new Date();
  function createTimeSeries(list) {
    const totalMinutes = 24 * 60; // 一天总共有1440分钟
    const interval = totalMinutes / list.length; // 根据列表长度计算时间间隔
    let timeSeries = [];

    for (let i = 0; i < list.length; i++) {
      // 计算每个时间点，从中午12点开始
      const minutes = Math.round(interval * i) + 720; // 在这里加720使起点为12:00
      const wrappedMinutes = minutes % totalMinutes; // 确保时间不会超过一天的分钟数
      const hours = Math.floor(wrappedMinutes / 60);
      const mins = wrappedMinutes % 60;

      // 格式化时间为 HH:mm 格式
      const formattedTime = `${hours.toString().padStart(2, '0')}:${mins.toString().padStart(2, '0')}`;
      timeSeries.push(formattedTime);
    }
    console.log(timeSeries)
    return timeSeries;
  }
  // 当滑块值改变时更新时间
  document.getElementById('timeSlider').addEventListener('input', function(e) {
    let minutesToAdd  = parseInt(e.target.value);
    let newTime = new Date(baseTime.getTime());
    newTime.setMinutes(newTime.getMinutes() + minutesToAdd *10);

    let cesiumTime = Cesium.JulianDate.fromDate(newTime);
    viewer.clock.currentTime = cesiumTime;
    // viewer.timeline.zoomTo(cesiumTime, Cesium.JulianDate.addDays(cesiumTime, 1, new Cesium.JulianDate()));
  });
  // inter = setInterval(() => {
  //   // 改变时间设置光照效果
  //   let date = new Date().getTime() + time
  //   let utc = Cesium.JulianDate.fromDate(new Date(date))
  //   //北京时间
  //   viewer.clockViewModel.currentTime = Cesium.JulianDate.addHours(utc, 0, new Cesium.JulianDate())
  //   time = time + 1000 * 1000
  //
  // }, 100)
  function updateLightAngle(angle_num) {
    let minutesToAdd = angle_num;
    let newTime = new Date(baseTime.getTime());
    newTime.setMinutes( minutesToAdd*10);

    let cesiumTime = Cesium.JulianDate.fromDate(newTime);
    viewer.clock.currentTime = cesiumTime;
  }
  function draw_diagram(intersects,cartesian3){
    // console.log('光线反射值:', reflectance);
    let light_list=[]
    let reflectance=0
    const step = 2; // 或根据需要调整
    let currentValue=0

        // let intersect_judge=
        // updateLightAngle(currentValue)
        reflectance=calculate_normal(intersects,cartesian3)
    // console.log(reflectance,'reflectance')
    return reflectance
        // slider.value = currentValue; // 更新滑块的值
        // console.log(`Current slider value: ${currentValue}`); // 在控制台输出当前值


  }

  // Fly the camera to San Francisco at the given longitude, latitude, and height.
  viewer.camera.flyTo({
    destination: Cesium.Cartesian3.fromDegrees(11.572176066553844, 48.13941501948902, 900),

    orientation: {
      heading: Cesium.Math.toRadians(0.0),
      pitch: Cesium.Math.toRadians(-15.0),
    }
  });

</script>
</div>
</body>
</html>